package com.persagy.dmp.report.enumeration;

import java.util.HashSet;
import java.util.Set;

/**
 * @author: fengyanjie
 * @date: 2020-11-19
 * @verison: 1.0
 */
public enum DateType {
    /**
     * 年
     */
    YEAR("year"),
    /**
     * 月
     */
    MONTH("month"),
    /**
     * 日
     */
    DAY("day"),
    /**
     * 时
     */
    HOUR("hour"),

    /**
     * 周
     */
    WEEK("week"),

    /**
     * 季度 1:0101-0401，2:0401-0701，3:0701-1001，4: 1001-0101  (日期前闭后开)
     */
    SEASON("season");

    private String code;

    DateType(String code) {
        this.code = code;
    }

    public String getCode() {
        return code;
    }

    public static DateType getByCode(String code) {
        for (DateType value : DateType.values()) {
            if(value.getCode().equals(code)){
                return value;
            }
        }
        return null;
    }

    public static Set<String> getAllCode() {
        Set<String> set = new HashSet<>();
        for (DateType value : DateType.values()) {
            set.add(value.getCode());
        }
        return set;
    }
}
