package com.persagy.dmp.report.feign;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.model.ClassDefModel;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @author: fengyanjie
 * @date: 2020-11-25
 * @verison: 1.0
 */
@FeignClient(name = "dmp-rwd")
public interface RwdClient {

    @PostMapping("/rwd/instance/object/query")
    PagedResponse<ObjectNode> queryObject(@RequestParam(name = "projectId") String projectId,
                                          @RequestParam(name = "groupCode") String groupCode,
                                          @RequestBody JacksonCriteria criteria);

    @PostMapping("/rwd/def/class/query")
    PagedResponse<ClassDefModel> queryClass(@RequestParam(name = "groupCode") String groupCode, @RequestBody JacksonCriteria criteria);
}
