package com.persagy.dmp.report.sharding;

import com.xiaoju.uemc.tinyid.client.utils.TinyId;
import org.apache.shardingsphere.spi.keygen.ShardingKeyGenerator;

import java.util.Properties;

/**
 * @author: FengYanjie
 * @date: 2020-12-30
 * @verison: 1.0
 */
public class GroupKeyTinyidShardingAlgorithm implements ShardingKeyGenerator {
    /**
     * 自定义的生成方案类型
     */
    @Override
    public String getType() {
        return "tinyid";
    }

    /**
     * 核心方法-生成主键ID
     */
    @Override
    public Comparable generateKey() {
        Long id = TinyId.nextId("test");
        return id;
    }

    @Override
    public Properties getProperties() {
        return null;
    }

    @Override
    public void setProperties(Properties properties) {
    }
}
