package com.persagy.dmp.report;

import com.persagy.common.date.DateUtils;
import com.persagy.common.json.JacksonMapper;
import com.persagy.dmp.report.common.criteria.JacksonCriteria;
import com.persagy.dmp.report.common.json.JsonMapper;
import com.persagy.dmp.report.entity.BaseEntity;
import com.persagy.dmp.report.entity.ReportAlarmRecord;
import com.persagy.dmp.report.entity.ReportConfigGroup;
import com.persagy.dmp.report.enumeration.DateType;
import com.persagy.dmp.report.service.DataExecutorService;
import com.persagy.dmp.report.service.ReportUtils;
import com.querydsl.jpa.impl.JPAQueryFactory;
import com.xiaoju.uemc.tinyid.client.utils.TinyId;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

@Slf4j
@SpringBootTest
@RunWith(SpringRunner.class)
public class test {

    @Autowired
    JPAQueryFactory queryFactory;

    @Autowired
    DataExecutorService dataExecutorService;

    @Autowired
    ReportUtils reportUtils;

    @Test
    public void test() {
        Long id = TinyId.nextId("test");
        System.err.println(id);
        List<Long> ids = TinyId.nextId("test", 10);
        for (Long aLong : ids) {
            System.err.println(aLong);
        }
    }

//    @Test
//    public void test1() {
//        QAlarmItem qt = QAlarmItem.alarmItem;
//        List<String> fetch = queryFactory.selectDistinct(qt.code).from(qt).where(qt.valid.eq(1)).fetch();
//        fetch.forEach(item -> System.out.println(item));
//    }

    @Test
    public void test2() throws Exception {
        List<ReportConfigGroup> reportConfigGroupList = new ArrayList<>();
        List<Object[]> valueList = Arrays.asList(new String[]{"1022", "Eq"},
                new String[]{"1022", "Sy"},
                new String[]{"1021", "Eq"},
                new String[]{"1021", "Sy"},
                new String[]{"1009", "Sp"},
                new String[]{"1009", "Bd"},
                new String[]{"1020", "Sp"},
                new String[]{"1020", "Bd"}
        );
        ReportConfigGroup itemCodeCategory = new ReportConfigGroup("item_code,category", valueList);

        reportConfigGroupList.add(itemCodeCategory);
        List<Object[]> level = Arrays.asList(new String[]{"A"}, new String[]{"B"}, new String[]{"C"});
        reportConfigGroupList.add(new ReportConfigGroup("level", level));
        List<Object[]> alarm_state = Collections.singletonList(new String[]{"1"});
        reportConfigGroupList.add(new ReportConfigGroup("alarm_state", alarm_state));
        List<Object[]> class_code = Collections.singletonList(new String[]{"ACCCOP"});
        reportConfigGroupList.add(new ReportConfigGroup("class_code", class_code));
        reportConfigGroupList.add(new ReportConfigGroup("project_id", Collections.singletonList(new String[]{"Pj1101050029"})));

        List<BaseEntity> list = new ArrayList<>();

        ReportAlarmRecord entity = new ReportAlarmRecord();
        entity.setItemCode("1022");
        entity.setCategory("Sy");
        entity.setLevel("A");
        entity.setAlarmState("1");
        entity.setClassCode("ACCCOP");
        entity.setProjectId("Pj1101050029");
        list.add(entity);

        ReportAlarmRecord entity2 = new ReportAlarmRecord();
        entity2.setItemCode("1010");
        entity2.setProjectId("Pj1101050029");
        entity2.setCategory("Sp");
        entity2.setClassCode("ACATFC");
        entity2.setLevel("D");
        entity2.setAlarmState("4");
        entity2.setYear("2020");
        entity2.setCreateTime("2020");
        entity2.setDateType(DateType.YEAR);
        entity2.setAlarmRecordNum(123456L);
        list.add(entity2);

        List<JacksonCriteria.Calculated> calculatedColumns = new ArrayList<>();
        calculatedColumns.add(new JacksonCriteria.Calculated("alarmRecordNum"));
        calculatedColumns.add(new JacksonCriteria.Calculated("alarmRecordNum2"));
        System.err.println(JacksonMapper.toFormatJson(reportConfigGroupList));
        List<BaseEntity> resultList = new ArrayList<>();
        reportUtils.initData(0, reportConfigGroupList, ReportAlarmRecord.class, resultList);
        reportUtils.addList(list, resultList, calculatedColumns);

        System.err.println(JacksonMapper.toFormatJson(list));
    }


    @Test
    public void test3() throws Exception {
        String tableName = "alarm_record";
        //统计数据
        dataExecutorService.reportAlarmRecord(DateType.YEAR, DateUtils.parse("20200101000000"), DateUtils.parse("20210101000000"));
    }

    @Test
    public void test4() throws Exception {
        String tableName = "rwd_object";
        //统计数据
        dataExecutorService.reportRwdObject(DateType.YEAR, DateUtils.parse("20200101000000"), DateUtils.parse("20210101000000"));
    }


    @Test
    public void test5() throws Exception {
        String json = "[[\"item_code\"],[\"project_id\"],[\"category\"],[\"obj_id\"],[\"class_code\"],[\"level\"],[\"alarm_state\"]]";
        List<Object> list = JsonMapper.json2List(json);
        System.err.println(list);
    }
}
















